function [ue, f, Ex] = data(i, alpha)

if nargin < 2, alpha = 0; end

switch i
  
  % ********** u0 *****     
 case 0, 
   ue = @(x,y)((x'.*(1-x'))*(y.*(1-y)));
   f  = @(x,y)(2*(x'*0+1)*(y.*(1-y)) + 2*(x'.*(1-x'))*(y*0+1) + ue(x,y));
   Ex = 832/75;
   
  % ********** u1 *****   
 case 1,
  ue = @(x,y)(cos(pi*x'/2)*cos(pi*y/2));
  f  = @(x,y)((pi^2/2+1)*ue(x,y));
  Ex = pi^2/2+1;
  
  % ********** u2 *****
 case 2,
  ue = @(x,y)((cos(pi*x'/2).*(abs(x)'.^alpha))*cos(pi*y/2));
  f  = @(x,y)((((pi^2/2+1-alpha*(alpha-1)./x'.^2).*cos(pi*x'/2) + ...
		pi*alpha./x'.*sin(pi*x'/2)).*(abs(x)'.^alpha))*cos(pi*y/2));
  if alpha == 2.5
    Ex = -37/48+1/12*pi^2+25/4/pi^2+15/pi^4-240/pi^6;
  elseif alpha == 1.75
    Ex = 0.89842934515214;
  elseif alpha == 1.55
    Ex = 1.03836258634506;
  elseif alpha == 1.51
    Ex = 1.07135366634784;
  else
    Ex = NaN;
  end
  
  % ********** u3 *****  
 case 3,
  r2 = @(x,y)(repmat(x'.^2, 1, length(y)) + ...
	    repmat(y.^2, length(x), 1));
  ue = @(x,y)((cos(pi*x'/2)*cos(pi*y/2)).*(r2(x,y).^(alpha/2)));
  f  = @(x,y)(((pi^2/2+1-alpha^2./r2(x,y)).*(cos(pi*x'/2)*cos(pi*y/2)) + ...
	       pi*alpha./r2(x,y).*((x'.*sin(pi*x'/2))*cos(pi*y/2) + ...
				   cos(pi*x'/2)*(sin(pi*y/2).*y))).*r2(x,y).^(alpha/2));
  if alpha == 1.5
    Ex = 2.03298164745868;
  elseif alpha == 1.1
    Ex = 2.42117118774908;
  elseif alpha == 1.01
    Ex = 2.53748159036187;
  else
    Ex = NaN;
  end
end