% mesh definition
lx = 1; ly = 1; p = 3;
x = linspace(-1, 1, 2^lx+1);
y = linspace(-1, 1, 2^ly+1);
%x = linspace(-1, 1, 4);
%y = linspace(-1, 1, 4);

AE = @(x,y)(1);
c  = @(x,y)(1);

[ue, f, Ex] = data(0);
[ue, f, Ex] = data(1);
[ue, f, Ex] = data(2, 1.75);
[ue, f, Ex] = data(3, 1.5);

[u, E(j,l)] = solve(x, y, p, AE, c, f);
u = u';

xplot = linspace(min(x), max(x), 101);
yplot = linspace(min(x), max(x), 101);
[U, xplot, yplot] = evaluateSolution(x, y, p, u, xplot, yplot);

figure(1)
clf
h = surf(xplot, yplot, U, 'linestyle', 'none'); hold on
Ix = find(ismember(xplot, x));
Iy = find(ismember(yplot, y));
for j=1:length(Iy)
  plot3(xplot, y(j)*ones(size(xplot)), U(Iy(j), :), 'k-', 'linewidth', 2);
end
for j=1:length(Ix)
  plot3(x(j)*ones(size(yplot)), yplot, U(:, Ix(j)), 'k-', 'linewidth', 2);
end
hold off
xlabel('x'); ylabel('y');
%view(2)
colormap(hot)

figure(2),clf
surf(xplot, yplot, ue(xplot,yplot)', 'linestyle', 'none');
xlabel('x'); ylabel('y');
colormap(hot)

